/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIFacebookService.idl
 */

#ifndef __gen_flockIFacebookService_h__
#define __gen_flockIFacebookService_h__


#ifndef __gen_flockISocialWebService_h__
#include "flockISocialWebService.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    flockIFacebookAccount */
#define FLOCKIFACEBOOKACCOUNT_IID_STR "480e420a-5f4f-11dc-8314-0800200c9a66"

#define FLOCKIFACEBOOKACCOUNT_IID \
  {0x480e420a, 0x5f4f, 0x11dc, \
    { 0x83, 0x14, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Represents a Facebook account.
 *
 * More documentation here:
 * http://wiki.flock.com/index.php?title=Danphe:AccountsAndServices
 *
 * @see flockISocialWebService
 */
class NS_NO_VTABLE flockIFacebookAccount : public flockISocialWebServiceAccount {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(FLOCKIFACEBOOKACCOUNT_IID)

  /**
   * When content is dragged onto a Facebook FriendCard to be shared with that
   * friend, we want to send the friend a message and also use the "Share Link"
   * feature in Facebook to attach the content to the message.
   *
   * @param aFriendURN (in) the RDF node ID of the friend for whom we are
   *        trying to get a list of actions for.
   * @param aTransferable (in) use to determine type of content
   */
  /* void sendMessageWithSharedLink (in AString aFriendURN, in nsITransferable aTransferable); */
  NS_IMETHOD SendMessageWithSharedLink(const nsAString & aFriendURN, nsITransferable *aTransferable) = 0;

  /**
   * Sends a "Check out Flock!" kind of message to the selected friend.
   *
   * @param aFriendURN (in) the URN of the friend to whom we're sending mail.
   */
  /* void shareFlock (in AString aFriendURN); */
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN) = 0;

  /**
   * Posts the link in the given transferable on the user's profile. If the
   * transferable is null, then the current tab's URL is posted.
   * @param aTransferable (in) drag and drop data
   */
  /* void postLink (in nsITransferable aTransferable); */
  NS_IMETHOD PostLink(nsITransferable *aTransferable) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIFACEBOOKACCOUNT \
  NS_IMETHOD SendMessageWithSharedLink(const nsAString & aFriendURN, nsITransferable *aTransferable); \
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN); \
  NS_IMETHOD PostLink(nsITransferable *aTransferable); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIFACEBOOKACCOUNT(_to) \
  NS_IMETHOD SendMessageWithSharedLink(const nsAString & aFriendURN, nsITransferable *aTransferable) { return _to SendMessageWithSharedLink(aFriendURN, aTransferable); } \
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN) { return _to ShareFlock(aFriendURN); } \
  NS_IMETHOD PostLink(nsITransferable *aTransferable) { return _to PostLink(aTransferable); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIFACEBOOKACCOUNT(_to) \
  NS_IMETHOD SendMessageWithSharedLink(const nsAString & aFriendURN, nsITransferable *aTransferable) { return !_to ? NS_ERROR_NULL_POINTER : _to->SendMessageWithSharedLink(aFriendURN, aTransferable); } \
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN) { return !_to ? NS_ERROR_NULL_POINTER : _to->ShareFlock(aFriendURN); } \
  NS_IMETHOD PostLink(nsITransferable *aTransferable) { return !_to ? NS_ERROR_NULL_POINTER : _to->PostLink(aTransferable); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIFacebookAccount
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIFACEBOOKACCOUNT

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIFacebookAccount)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void sendMessageWithSharedLink (in AString aFriendURN, in nsITransferable aTransferable); */
NS_IMETHODIMP _MYCLASS_::SendMessageWithSharedLink(const nsAString & aFriendURN, nsITransferable *aTransferable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void shareFlock (in AString aFriendURN); */
NS_IMETHODIMP _MYCLASS_::ShareFlock(const nsAString & aFriendURN)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void postLink (in nsITransferable aTransferable); */
NS_IMETHODIMP _MYCLASS_::PostLink(nsITransferable *aTransferable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIFacebookService_h__ */
