/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIAccountService.idl
 */

#ifndef __gen_flockIAccountService_h__
#define __gen_flockIAccountService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIObserver_h__
#include "nsIObserver.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    flockIAccountObserver */
#define FLOCKIACCOUNTOBSERVER_IID_STR "04f22e98-9599-11dc-8314-0800200c9a66"

#define FLOCKIACCOUNTOBSERVER_IID \
  {0x04f22e98, 0x9599, 0x11dc, \
    { 0x83, 0x14, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

class NS_NO_VTABLE flockIAccountObserver : public nsIObserver {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(FLOCKIACCOUNTOBSERVER_IID)

  /**
   * onAccountAuthenticated
   * Functionality to be performed when AccountService observes that an account
   * has been authenticated
   * @param aAccountUrn : URN of Account that has been authenticated
   */
  /* void onAccountAuthenticated (in AString aAccountUrn); */
  NS_IMETHOD OnAccountAuthenticated(const nsAString & aAccountUrn) = 0;

  /**
    * onAccountUnauthenticated
    * Functionality to be performed when AccountService observes that an account
    * has just been unauthenticated
    * @param aAccountUrn: URN of Account that has been unauthenticated
    */
  /* void onAccountUnauthenticated (in AString aAccountUrn); */
  NS_IMETHOD OnAccountUnauthenticated(const nsAString & aAccountUrn) = 0;

  /**
   * onAccountRefresh
   * Functionality to be performed when AccountService observes that an account
   * has just been unauthenticated
   * @param aAccountUrn: URN of Account that has started refreshing
   */
  /* void onAccountRefreshing (in AString aAccountUrn); */
  NS_IMETHOD OnAccountRefreshing(const nsAString & aAccountUrn) = 0;

  /**
   * onAccountNoLongerRefreshing
   * Functionality to be performed when AccountService observes that an account
   * has just been unauthenticated
   * @param aAccountUrn: URN of Account that has finished refreshing
   */
  /* void onAccountNoLongerRefreshing (in AString aAccountUrn); */
  NS_IMETHOD OnAccountNoLongerRefreshing(const nsAString & aAccountUrn) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIACCOUNTOBSERVER \
  NS_IMETHOD OnAccountAuthenticated(const nsAString & aAccountUrn); \
  NS_IMETHOD OnAccountUnauthenticated(const nsAString & aAccountUrn); \
  NS_IMETHOD OnAccountRefreshing(const nsAString & aAccountUrn); \
  NS_IMETHOD OnAccountNoLongerRefreshing(const nsAString & aAccountUrn); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIACCOUNTOBSERVER(_to) \
  NS_IMETHOD OnAccountAuthenticated(const nsAString & aAccountUrn) { return _to OnAccountAuthenticated(aAccountUrn); } \
  NS_IMETHOD OnAccountUnauthenticated(const nsAString & aAccountUrn) { return _to OnAccountUnauthenticated(aAccountUrn); } \
  NS_IMETHOD OnAccountRefreshing(const nsAString & aAccountUrn) { return _to OnAccountRefreshing(aAccountUrn); } \
  NS_IMETHOD OnAccountNoLongerRefreshing(const nsAString & aAccountUrn) { return _to OnAccountNoLongerRefreshing(aAccountUrn); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIACCOUNTOBSERVER(_to) \
  NS_IMETHOD OnAccountAuthenticated(const nsAString & aAccountUrn) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnAccountAuthenticated(aAccountUrn); } \
  NS_IMETHOD OnAccountUnauthenticated(const nsAString & aAccountUrn) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnAccountUnauthenticated(aAccountUrn); } \
  NS_IMETHOD OnAccountRefreshing(const nsAString & aAccountUrn) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnAccountRefreshing(aAccountUrn); } \
  NS_IMETHOD OnAccountNoLongerRefreshing(const nsAString & aAccountUrn) { return !_to ? NS_ERROR_NULL_POINTER : _to->OnAccountNoLongerRefreshing(aAccountUrn); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIAccountObserver
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIACCOUNTOBSERVER

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIAccountObserver)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void onAccountAuthenticated (in AString aAccountUrn); */
NS_IMETHODIMP _MYCLASS_::OnAccountAuthenticated(const nsAString & aAccountUrn)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onAccountUnauthenticated (in AString aAccountUrn); */
NS_IMETHODIMP _MYCLASS_::OnAccountUnauthenticated(const nsAString & aAccountUrn)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onAccountRefreshing (in AString aAccountUrn); */
NS_IMETHODIMP _MYCLASS_::OnAccountRefreshing(const nsAString & aAccountUrn)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void onAccountNoLongerRefreshing (in AString aAccountUrn); */
NS_IMETHODIMP _MYCLASS_::OnAccountNoLongerRefreshing(const nsAString & aAccountUrn)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    flockIAccountService */
#define FLOCKIACCOUNTSERVICE_IID_STR "1700acd6-9599-11dc-8314-0800200c9a66"

#define FLOCKIACCOUNTSERVICE_IID \
  {0x1700acd6, 0x9599, 0x11dc, \
    { 0x83, 0x14, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

class NS_NO_VTABLE flockIAccountService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(FLOCKIACCOUNTSERVICE_IID)

  /**
   * addObserver
   * Registers a given listener for a notifications regarding the specified
   * topic.
   * @param aObserver : The interface pointer which will receive notifications.
   */
  /* void addObserver (in flockIAccountObserver aObserver); */
  NS_IMETHOD AddObserver(flockIAccountObserver *aObserver) = 0;

  /**
   * removeObserver
   * Unregisters a given listener from notifications regarding the specified
   * topic.
   * @param aObserver : The interface pointer which will stop receiving
   *                    notifications.
   */
  /* void removeObserver (in flockIAccountObserver aObserver); */
  NS_IMETHOD RemoveObserver(flockIAccountObserver *aObserver) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIACCOUNTSERVICE \
  NS_IMETHOD AddObserver(flockIAccountObserver *aObserver); \
  NS_IMETHOD RemoveObserver(flockIAccountObserver *aObserver); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIACCOUNTSERVICE(_to) \
  NS_IMETHOD AddObserver(flockIAccountObserver *aObserver) { return _to AddObserver(aObserver); } \
  NS_IMETHOD RemoveObserver(flockIAccountObserver *aObserver) { return _to RemoveObserver(aObserver); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIACCOUNTSERVICE(_to) \
  NS_IMETHOD AddObserver(flockIAccountObserver *aObserver) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddObserver(aObserver); } \
  NS_IMETHOD RemoveObserver(flockIAccountObserver *aObserver) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveObserver(aObserver); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIAccountService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIACCOUNTSERVICE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIAccountService)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void addObserver (in flockIAccountObserver aObserver); */
NS_IMETHODIMP _MYCLASS_::AddObserver(flockIAccountObserver *aObserver)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeObserver (in flockIAccountObserver aObserver); */
NS_IMETHODIMP _MYCLASS_::RemoveObserver(flockIAccountObserver *aObserver)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIAccountService_h__ */
