/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIMediaUploadWebService.idl
 */

#ifndef __gen_flockIMediaUploadWebService_h__
#define __gen_flockIMediaUploadWebService_h__


#ifndef __gen_flockIMediaWebService_h__
#include "flockIMediaWebService.h"
#endif

#ifndef __gen_flockIListener_h__
#include "flockIListener.h"
#endif

#ifndef __gen_flockIPhotoUpload_h__
#include "flockIPhotoUpload.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    flockIMediaUploadWebService */
#define FLOCKIMEDIAUPLOADWEBSERVICE_IID_STR "eb57a51a-82c2-4bf6-af06-06379fe694d9"

#define FLOCKIMEDIAUPLOADWEBSERVICE_IID \
  {0xeb57a51a, 0x82c2, 0x4bf6, \
    { 0xaf, 0x06, 0x06, 0x37, 0x9f, 0xe6, 0x94, 0xd9 }}

/**
 * Represents a web service that supports uploading of
 * rich media (eg. photos, video).
 *
 * More documentation here:
 * http://wiki.flock.com/index.php?title=Danphe:AccountsAndServices
 *
 * @see flockIMediaWebServiceAccount
 * @see flockIMediaUploadAccount
 */
class NS_NO_VTABLE flockIMediaUploadWebService : public flockIMediaWebService {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(FLOCKIMEDIAUPLOADWEBSERVICE_IID)

  /**
   * Query the server to get information about the current user's account
   * @param aListener (in) the listener used to pass the result.
   *                  aListener.onSuccess(result, topic) will be return,
   *                  only result holding a relevant value.
   *
   *                  result is a nsIPropertyBag2 holding the following values:
   *                  @li boolean isPremium;
   *                  @li string maxFileSize;
   *                  @li string maxSpace;
   *                  @li string usageUnits;
   *                  @li string usedSpace;
   *                  @li string username;
   */
  /* void getAccountStatus (in flockIListener aListener); */
  NS_IMETHOD GetAccountStatus(flockIListener *aListener) = 0;

  /**
   * Gets albums that are only upload endpoints.
   * @param aListener (in) Specifies a callback listener
   * @param aUsername (in) Specifies a username to operate the search as
   */
  /* void getAlbumsForUpload (in flockIListener aListener, in AString aUsername); */
  NS_IMETHOD GetAlbumsForUpload(flockIListener *aListener, const nsAString & aUsername) = 0;

  /* void createAlbum (in flockIListener aListener, in AString aAlbumName); */
  NS_IMETHOD CreateAlbum(flockIListener *aListener, const nsAString & aAlbumName) = 0;

  /* boolean supportsFeature (in AString aFeature); */
  NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval) = 0;

  /* void upload (in flockIPhotoUploadAPIListener aListener, in flockIPhotoUpload aUpload, in AString aFilename); */
  NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aListener, flockIPhotoUpload *aUpload, const nsAString & aFilename) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIMEDIAUPLOADWEBSERVICE \
  NS_IMETHOD GetAccountStatus(flockIListener *aListener); \
  NS_IMETHOD GetAlbumsForUpload(flockIListener *aListener, const nsAString & aUsername); \
  NS_IMETHOD CreateAlbum(flockIListener *aListener, const nsAString & aAlbumName); \
  NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval); \
  NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aListener, flockIPhotoUpload *aUpload, const nsAString & aFilename); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIMEDIAUPLOADWEBSERVICE(_to) \
  NS_IMETHOD GetAccountStatus(flockIListener *aListener) { return _to GetAccountStatus(aListener); } \
  NS_IMETHOD GetAlbumsForUpload(flockIListener *aListener, const nsAString & aUsername) { return _to GetAlbumsForUpload(aListener, aUsername); } \
  NS_IMETHOD CreateAlbum(flockIListener *aListener, const nsAString & aAlbumName) { return _to CreateAlbum(aListener, aAlbumName); } \
  NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval) { return _to SupportsFeature(aFeature, _retval); } \
  NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aListener, flockIPhotoUpload *aUpload, const nsAString & aFilename) { return _to Upload(aListener, aUpload, aFilename); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIMEDIAUPLOADWEBSERVICE(_to) \
  NS_IMETHOD GetAccountStatus(flockIListener *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAccountStatus(aListener); } \
  NS_IMETHOD GetAlbumsForUpload(flockIListener *aListener, const nsAString & aUsername) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAlbumsForUpload(aListener, aUsername); } \
  NS_IMETHOD CreateAlbum(flockIListener *aListener, const nsAString & aAlbumName) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateAlbum(aListener, aAlbumName); } \
  NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SupportsFeature(aFeature, _retval); } \
  NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aListener, flockIPhotoUpload *aUpload, const nsAString & aFilename) { return !_to ? NS_ERROR_NULL_POINTER : _to->Upload(aListener, aUpload, aFilename); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIMediaUploadWebService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIMEDIAUPLOADWEBSERVICE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIMediaUploadWebService)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void getAccountStatus (in flockIListener aListener); */
NS_IMETHODIMP _MYCLASS_::GetAccountStatus(flockIListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getAlbumsForUpload (in flockIListener aListener, in AString aUsername); */
NS_IMETHODIMP _MYCLASS_::GetAlbumsForUpload(flockIListener *aListener, const nsAString & aUsername)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void createAlbum (in flockIListener aListener, in AString aAlbumName); */
NS_IMETHODIMP _MYCLASS_::CreateAlbum(flockIListener *aListener, const nsAString & aAlbumName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean supportsFeature (in AString aFeature); */
NS_IMETHODIMP _MYCLASS_::SupportsFeature(const nsAString & aFeature, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void upload (in flockIPhotoUploadAPIListener aListener, in flockIPhotoUpload aUpload, in AString aFilename); */
NS_IMETHODIMP _MYCLASS_::Upload(flockIPhotoUploadAPIListener *aListener, flockIPhotoUpload *aUpload, const nsAString & aFilename)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    flockIMediaUploadAccount */
#define FLOCKIMEDIAUPLOADACCOUNT_IID_STR "d610cb10-74e1-11db-9fe1-0800200c9a66"

#define FLOCKIMEDIAUPLOADACCOUNT_IID \
  {0xd610cb10, 0x74e1, 0x11db, \
    { 0x9f, 0xe1, 0x08, 0x00, 0x20, 0x0c, 0x9a, 0x66 }}

/**
 * Represents a web service account that supports uploading of rich media (eg.
 * photos, video).
 *
 * @see flockIMediaWebService
 * @see flockIMediaWebServiceAccount
 */
class NS_NO_VTABLE flockIMediaUploadAccount : public flockIMediaWebServiceAccount {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(FLOCKIMEDIAUPLOADACCOUNT_IID)

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIMEDIAUPLOADACCOUNT \
  /* no methods! */

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIMEDIAUPLOADACCOUNT(_to) \
  /* no methods! */

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIMEDIAUPLOADACCOUNT(_to) \
  /* no methods! */

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIMediaUploadAccount
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIMEDIAUPLOADACCOUNT

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIMediaUploadAccount)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIMediaUploadWebService_h__ */
