/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIYoutubeAccount.idl
 */

#ifndef __gen_flockIYoutubeAccount_h__
#define __gen_flockIYoutubeAccount_h__


#ifndef __gen_flockIWebService_h__
#include "flockIWebService.h"
#endif

#ifndef __gen_nsITransferable_h__
#include "nsITransferable.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    flockIYoutubeAccount */
#define FLOCKIYOUTUBEACCOUNT_IID_STR "c1d86481-e762-4cf6-bc0d-319174cf6ae6"

#define FLOCKIYOUTUBEACCOUNT_IID \
  {0xc1d86481, 0xe762, 0x4cf6, \
    { 0xbc, 0x0d, 0x31, 0x91, 0x74, 0xcf, 0x6a, 0xe6 }}

/**
 * Interface for YouTube Account methods.
 */
class NS_NO_VTABLE flockIYoutubeAccount : public flockIWebServiceAccount {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(FLOCKIYOUTUBEACCOUNT_IID)

  /**
   * Opens YouTube Private Message UI for friend specified by aFriendUrn.
   * Mail area is populated with message information provided in aTransferable
   * @param aFriendUrn (in)     URN of YouTube friend to send message to
   * @param aTransferable (in)  contents of Flock default message for YouTube
   */
  /* void youtubePrivateMessage (in AString aFriendUrn, in nsITransferable aTransferable); */
  NS_IMETHOD YoutubePrivateMessage(const nsAString & aFriendUrn, nsITransferable *aTransferable) = 0;

  /**
   * Opens YouTube Share Video UI for friend specified by aFriendUrn.
   * Mail area is populated with message information provided in aTransferable
   * @param aFriendUrn (in)     URN of YouTube friend to send message to
   * @param aTransferable (in)  contents of Flock default message for YouTube
   */
  /* void youtubeShareVideo (in AString aFriendUrn, in nsITransferable aTransferable); */
  NS_IMETHOD YoutubeShareVideo(const nsAString & aFriendUrn, nsITransferable *aTransferable) = 0;

  /**
   * Opens YouTube Private Message for friend specified by aFriendURN.
   * Mail area is populated with messaging to download and use Flock
   * @param aFriendURN (in)  URN for Youtube friend to send message to
   */
  /* void shareFlock (in AString aFriendURN); */
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIYOUTUBEACCOUNT \
  NS_IMETHOD YoutubePrivateMessage(const nsAString & aFriendUrn, nsITransferable *aTransferable); \
  NS_IMETHOD YoutubeShareVideo(const nsAString & aFriendUrn, nsITransferable *aTransferable); \
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIYOUTUBEACCOUNT(_to) \
  NS_IMETHOD YoutubePrivateMessage(const nsAString & aFriendUrn, nsITransferable *aTransferable) { return _to YoutubePrivateMessage(aFriendUrn, aTransferable); } \
  NS_IMETHOD YoutubeShareVideo(const nsAString & aFriendUrn, nsITransferable *aTransferable) { return _to YoutubeShareVideo(aFriendUrn, aTransferable); } \
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN) { return _to ShareFlock(aFriendURN); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIYOUTUBEACCOUNT(_to) \
  NS_IMETHOD YoutubePrivateMessage(const nsAString & aFriendUrn, nsITransferable *aTransferable) { return !_to ? NS_ERROR_NULL_POINTER : _to->YoutubePrivateMessage(aFriendUrn, aTransferable); } \
  NS_IMETHOD YoutubeShareVideo(const nsAString & aFriendUrn, nsITransferable *aTransferable) { return !_to ? NS_ERROR_NULL_POINTER : _to->YoutubeShareVideo(aFriendUrn, aTransferable); } \
  NS_IMETHOD ShareFlock(const nsAString & aFriendURN) { return !_to ? NS_ERROR_NULL_POINTER : _to->ShareFlock(aFriendURN); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIYoutubeAccount
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIYOUTUBEACCOUNT

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIYoutubeAccount)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void youtubePrivateMessage (in AString aFriendUrn, in nsITransferable aTransferable); */
NS_IMETHODIMP _MYCLASS_::YoutubePrivateMessage(const nsAString & aFriendUrn, nsITransferable *aTransferable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void youtubeShareVideo (in AString aFriendUrn, in nsITransferable aTransferable); */
NS_IMETHODIMP _MYCLASS_::YoutubeShareVideo(const nsAString & aFriendUrn, nsITransferable *aTransferable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void shareFlock (in AString aFriendURN); */
NS_IMETHODIMP _MYCLASS_::ShareFlock(const nsAString & aFriendURN)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIYoutubeAccount_h__ */
